# coding=utf-8
import sys
import psyco
import textwrap
import datetime
import math
import es
import gamethread
import playerlib

# Psyco soll den Code optimieren
psyco.full()

# Addon Info
info = es.AddonInfo()
info.name = 'Happy Hour'
info.version = '0.6'
info.author = 'TimeWaster'
info.url = 'http://www.timewaster.de/timewasters-happy-hour-script-for-css-eventscripts/'
info.basename = 'happyhour'
info.description = "TimeWaster's Happy Hour for ES 2.0 Python"

# Globale Variablen
hh_serverVars = ['hh_times', 'hh_warmupTimeToWait', 'hh_disableAdverts', 'hh_language', 'hh_timeInfo', 'hh_givePrimaryWeaponT', 'hh_givePrimaryWeaponCT', 'hh_giveSecondaryWeapon', 'hh_giveHEGrenade', 'hh_giveFlashBang', 'hh_giveSmokeGrenade', 'hh_giveArmor', 'hh_giveDefuser', 'hh_giveNightVision', 'hh_renewHEGrenade', 'hh_renewFlashGrenade', 'hh_renewSmokeGrenade', 'hh_bombsForAll', 'hh_timeFrameInfo', 'hh_startSound', 'hh_endSound', 'hh_startCommand', 'hh_endCommand', 'hh_text_moreInfo', 'hh_text_startIn5Mins', 'hh_text_startIn1Mins', 'hh_text_start', 'hh_text_endIn5Mins', 'hh_text_endIn1Mins', 'hh_text_runs', 'hh_text_next', 'hh_text_over', 'hh_text_userInfo', 'hh_text_joinInfo', 'hh_text_next_and', 'hh_text_next_day', 'hh_text_next_days', 'hh_text_next_hour', 'hh_text_next_hours', 'hh_text_next_minute', 'hh_text_next_minutes']
hh_enabled = False
hh_warmup = False
hh_timesSplit = ''

# Initialisiere Script
def load():
	global hh_timesSplit
	hh_logMsg('Loading and validating config...')
	for hh_serverVar in hh_serverVars:
		globals()[hh_serverVar] = es.ServerVar(hh_serverVar)
		globals()[hh_serverVar].set('-1')
	es.server.cmd('es_xmexec ../addons/eventscripts/happyhour/happyhour.cfg')
	es.server.cmd('es_xmexec ../addons/eventscripts/happyhour/language/%s.cfg' % str(hh_language))
	hh_run = 1
	for hh_serverVar in hh_serverVars:
		if globals()[hh_serverVar] == '-1':
			hh_logErrorMsg('Error in config: ' + hh_serverVar + ' is not declared or faulty.')
			hh_run = 0
	if not hh_run:
		es.unload('happyhour')
		return
	hh_textVars = ['hh_text_startIn5Mins', 'hh_text_startIn1Mins', 'hh_text_start', 'hh_text_endIn5Mins', 'hh_text_endIn1Mins', 'hh_text_runs', 'hh_text_over', 'hh_text_joinInfo']
	for hh_textVar in hh_textVars:
		globals()[hh_textVar + '_array'] = textwrap.wrap('--- Happy Hour ' + '-' * 42 + '     ' + str(globals()[hh_textVar]) + ' ' * 60 + str(hh_text_moreInfo) + ' ' + '-' * 60, 60)
	globals()['hh_text_userInfo_array'] = textwrap.wrap('--- Happy Hour ' + '-' * 42 + '     ' + str(hh_text_userInfo).replace('%1', str(hh_timeInfo)) + ' ' + '-' * 60, 60)
	hh_logMsg('DONE Loading and validating config.')
	es.set('happyhour_version', info.version)
	es.makepublic('happyhour_version')
	if not es.exists('saycommand', '!happy'):
		es.regsaycmd('!happy', 'happyhour/hh_info', 'This gives you informations about the Happy Hour.')
	globals()['happy_on'] = es.ServerVar('happy_on')
	globals()['happy_on'].set('0')
	es.flags('add', 'notify', 'happy_on')
	if str(hh_times) != '1':
		hh_timesSplit = str(hh_times).split(',')
		hh_x = 0
		while hh_x < len(hh_timesSplit):
			hh_timesSplit[hh_x] = hh_timesSplit[hh_x].strip().split('-')
			hh_y = 0
			while hh_y < len(hh_timesSplit[hh_x]):
				hh_timesSplit[hh_x][hh_y] = (int(hh_timesSplit[hh_x][hh_y][0:1]) - 1) * 1440 + int(hh_timesSplit[hh_x][hh_y][1:3]) * 60 + int(hh_timesSplit[hh_x][hh_y][3:5])
				hh_y += 1
			hh_x += 1
	hh_time()
	hh_logMsg('Started successfully.')

# Kille Script
def unload():
	global hh_warmup
	for hh_serverVar in hh_serverVars:
		globals()[hh_serverVar].set('-1')
	if es.exists('saycommand', '!happy'):
		es.unregsaycmd('!happy')
	gamethread.cancelDelayed('hh_timer1')
	gamethread.cancelDelayed('hh_timer2')

# rechne aus ob HH ist und was angezeigt werden soll
def hh_time(hh_repeat = True):
	global hh_enabled, hh_timesSplit
	hh_today = datetime.datetime.now()
	hh_timeNow = int(hh_today.weekday()) * 1440 + int(hh_today.hour) * 60 + int(hh_today.minute)
	hh_noDoubleAdvert = False
	if str(hh_times) == '1' or str(happy_on) == '1':
		if str(hh_disableAdverts) == '0' and str(happy_on) == '1' and not hh_enabled:
			for hh_text_start_line in hh_text_start_array:
				es.msg('#lightgreen', hh_text_start_line)
			if hh_startSound != '':
				es.cexec_all('play ' + str(hh_startSound))
			if hh_startCommand != '':
				es.commandv('hh_startCommand')
			hh_noDoubleAdvert = True
		if str(hh_disableAdverts) == '0' and str(hh_timeFrameInfo) != '0' and hh_timeNow % int(hh_timeFrameInfo) == 0 and not hh_noDoubleAdvert:
			for hh_text_runs_line in hh_text_runs_array:
				es.msg('#lightgreen', hh_text_runs_line)
		hh_enabled = True
	else:
		hh_nearestStart = 10100
		hh_nearestEnd = 10100
		hh_nearestStart2 = 10100
		hh_nearestEnd2 = 10100
		hh_isOn = False
		hh_x = 0
		while hh_x < len(hh_timesSplit):
			if hh_timesSplit[hh_x][0] - hh_timeNow > -1 and (hh_timesSplit[hh_x][0] - hh_timeNow) < hh_nearestStart:
				hh_nearestStart = hh_timesSplit[hh_x][0] - hh_timeNow
			if hh_timesSplit[hh_x][1] - hh_timeNow > -1 and (hh_timesSplit[hh_x][1] - hh_timeNow) < hh_nearestEnd:
				hh_nearestEnd = hh_timesSplit[hh_x][1] - hh_timeNow
			if hh_timesSplit[hh_x][0] < hh_nearestStart2:
				hh_nearestStart2 = hh_timesSplit[hh_x][0]
			if hh_timesSplit[hh_x][1] < hh_nearestEnd2:
				hh_nearestEnd2 = hh_timesSplit[hh_x][1]
			if hh_timesSplit[hh_x][0] <= hh_timeNow and hh_timesSplit[hh_x][1] >= hh_timeNow:
				hh_isOn = True
			hh_x += 1
		if hh_nearestStart == 10100:
			hh_nearestStart = 10080 - hh_timeNow + hh_nearestStart2
		if hh_nearestEnd == 10100:
			hh_nearestEnd = 10080 - hh_timeNow + hh_nearestEnd2
		if str(hh_disableAdverts) == '0':
			if hh_enabled:
				if hh_nearestEnd == 5:
					for hh_text_endIn5Mins_line in hh_text_endIn5Mins_array:
						es.msg('#lightgreen', hh_text_endIn5Mins_line)
					hh_noDoubleAdvert = True
				if hh_nearestEnd == 1:
					for hh_text_endIn1Mins_line in hh_text_endIn1Mins_array:
						es.msg('#lightgreen', hh_text_endIn1Mins_line)
					hh_noDoubleAdvert = True
				if hh_enabled != hh_isOn:
					for hh_text_over_line in hh_text_over_array:
						es.msg('#lightgreen', hh_text_over_line)
					if hh_endSound != '':
						es.cexec_all('play ' + str(hh_endSound))
					if hh_endCommand != '':
						es.commandv('hh_endCommand')
					hh_noDoubleAdvert = True
			else:
				if hh_nearestStart == 5:
					for hh_text_startIn5Mins_line in hh_text_startIn5Mins_array:
						es.msg('#lightgreen', hh_text_startIn5Mins_line)
					hh_noDoubleAdvert = True
				if hh_nearestStart == 1:
					for hh_text_startIn1Mins_line in hh_text_startIn1Mins_array:
						es.msg('#lightgreen', hh_text_startIn1Mins_line)
					hh_noDoubleAdvert = True
				if hh_enabled != hh_isOn:
					for hh_text_start_line in hh_text_start_array:
						es.msg('#lightgreen', hh_text_start_line)
					if hh_startSound != '':
						es.cexec_all('play ' + str(hh_startSound))
					if hh_startCommand != '':
						es.commandv('hh_startCommand')
					hh_noDoubleAdvert = True
		hh_enabled = hh_isOn
		if str(hh_disableAdverts) == '0' and str(hh_timeFrameInfo) != '0' and hh_timeNow % int(hh_timeFrameInfo) == 0 and not hh_noDoubleAdvert:
			if hh_enabled:
				for hh_text_runs_line in hh_text_runs_array:
					es.msg('#lightgreen', hh_text_runs_line)
			else:
				hh_days = math.floor(hh_nearestStart / 1440)
				hh_hours = math.floor((hh_nearestStart - (hh_days * 1440)) / 60)
				hh_minutes = hh_nearestStart - (hh_days * 1440) - (hh_hours * 60)
				hh_temp = ''
				if hh_days > 1:
					hh_temp += str(int(hh_days)) + ' ' + str(hh_text_next_days) + ', '
				if hh_days == 1:
					hh_temp += str(int(hh_days)) + ' ' + str(hh_text_next_day) + ', '
				if hh_hours > 1:
					hh_temp += str(int(hh_hours)) + ' ' + str(hh_text_next_hours) + ' ' + str(hh_text_next_and) + ' '
				if hh_hours == 1:
					hh_temp += str(int(hh_hours)) + ' ' + str(hh_text_next_hour) + ' ' + str(hh_text_next_and) + ' '
				if hh_minutes == 1:
					hh_temp += str(int(hh_minutes)) + ' ' + str(hh_text_next_minute)
				else:
					hh_temp += str(int(hh_minutes)) + ' ' + str(hh_text_next_minutes)
				hh_text_userInfo_array = textwrap.wrap('--- Happy Hour ' + '-' * 42 + '     ' + str(hh_text_next).replace('%1', hh_temp) + ' ' + '-' * 60, 60)
				for hh_text_userInfo_line in hh_text_userInfo_array:
					es.msg('#lightgreen', hh_text_userInfo_line)
	if hh_repeat:
		gamethread.delayedname(60, 'hh_timer1', hh_time)

# Starte Warmup Timer um Warmup Scripte zu beruecksichtigen
def es_map_start(event_var):
	global hh_warmup
	if str(hh_warmupTimeToWait) != '0':
		hh_warmup = True
		gamethread.delayedname(int(hh_warmupTimeToWait), 'hh_timer2', hh_endWarmup)

# Beende Warmup Timer
def hh_endWarmup():
	global hh_warmup
	hh_warmup = False

# Wenn Spieler spawned gib ihm die Waffen
def player_spawn(event_var):
	global hh_enabled, hh_warmup
	if hh_enabled and not hh_warmup and int(event_var['es_userteam']) > 1:
		hh_Player = playerlib.getPlayer(event_var['userid'])
		if not hh_Player.getPrimary():
			if str(hh_givePrimaryWeaponT) != '' and int(event_var['es_userteam']) == 2:
				es.server.cmd('es_xgive %s %s' % (event_var['userid'], str(hh_givePrimaryWeaponT)))
			if str(hh_givePrimaryWeaponCT) != '' and int(event_var['es_userteam']) == 3:
				es.server.cmd('es_xgive %s %s' % (event_var['userid'], str(hh_givePrimaryWeaponCT)))
		if str(hh_giveSecondaryWeapon) != '' and hh_Player.getSecondary() and hh_Player.getSecondary() != str(hh_giveSecondaryWeapon):
			es.server.cmd('es_xremove %s' % hh_Player.getWeaponIndex(hh_Player.getSecondary()))
		if str(hh_giveSecondaryWeapon) != '' and hh_Player.getSecondary() != str(hh_giveSecondaryWeapon):
			es.server.cmd('es_xgive %s %s' % (event_var['userid'], str(hh_giveSecondaryWeapon)))
		if str(hh_giveHEGrenade) != '0' and hh_Player.getHE() == 0:
			es.server.cmd('es_xgive %s %s' % (event_var['userid'], 'weapon_hegrenade'))
		if str(hh_giveSmokeGrenade) != '0' and hh_Player.getSG() == 0:
			es.server.cmd('es_xgive %s %s' % (event_var['userid'], 'weapon_smokegrenade'))
		if int(hh_giveFlashBang) > 0 and hh_Player.getFB() == 0:
			es.server.cmd('es_xgive %s %s' % (event_var['userid'], 'weapon_flashbang'))
		if int(hh_giveFlashBang) > 1 and hh_Player.getFB() == 1:
			es.server.cmd('es_xgive %s %s' % (event_var['userid'], 'weapon_flashbang'))
		if str(hh_giveArmor) != '0' and hh_Player.getArmor() != int(hh_giveArmor):
			hh_Player.setArmor(int(hh_giveArmor))
		if str(hh_giveNightVision) != '0' and hh_Player.hasNightvision() == 0:
			hh_Player.setNightvision(1)
		if str(es.ServerVar('eventscripts_currentmap')).find('de_') == 0:
			if str(hh_giveDefuser) != '0' and int(event_var['es_userteam']) == 3 and hh_Player.hasDefuser() == 0:
				hh_Player.setDefuser(1)
			if str(hh_bombsForAll) != '0' and int(event_var['es_userteam']) == 2 and not hh_Player.hasC4():
				es.server.cmd('es_xgive %s %s' % (event_var['userid'], 'weapon_c4'))

# Smoke Grenade erneuern wenn erwuenscht
def hegrenade_detonate(event_var):
	if hh_enabled and str(hh_renewHEGrenade) == '1':
		es.server.cmd('es_xgive %s %s' % (event_var['userid'], 'weapon_hegrenade'))

# Smoke Grenade erneuern wenn erwuenscht
def flashbang_detonate(event_var):
	if hh_enabled and str(hh_renewFlashGrenade) == '1':
		es.server.cmd('es_xgive %s %s' % (event_var['userid'], 'weapon_flashbang'))

# Smoke Grenade erneuern wenn erwuenscht
def smokegrenade_detonate(event_var):
	if hh_enabled and str(hh_renewSmokeGrenade) == '1':
		es.server.cmd('es_xgive %s %s' % (event_var['userid'], 'weapon_smokegrenade'))

# Gib user Infos
def hh_info():
	if str(hh_disableAdverts) == '0':
		for hh_text_userInfo_line in hh_text_userInfo_array:
			es.tell(es.getcmduserid(), '#lightgreen', hh_text_userInfo_line)

# Gib user Infos wenn er zum ersten mal auf den Server kommt
def player_activate(event_var):
	if hh_enabled and str(hh_disableAdverts) == '0':
		for hh_text_joinInfo_line in hh_text_joinInfo_array:
			es.tell(event_var['userid'], '#lightgreen', hh_text_joinInfo_line)

# Wenn override angemacht wird lse sofort hh_time aus
def server_cvar(event_var):
	if event_var['cvarname'] == 'happy_on':
		hh_time(False)

# Log Nachrichten mit Sriptname
def hh_logMsg(hh_msg):
	print info.name + ': ' + hh_msg

# Log fehler Nachrichten mit Sriptname
def hh_logErrorMsg(hh_msg):
	print info.name + ': ' + hh_msg
	es.log(info.name + ': ' + hh_msg)
